package dev.flyfish.framework.bean;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 用来描述分页数据的bean
 *
 * @author Mr.Wang
 */
public class PageResult<T> extends Result<List<T>> {

    public static final Pageable DEFAULT_PAGE = PageRequest.of(0, 20);

    private PageBean page;

    private Integer count;

    public PageResult(String errCode, String errMsg, Page<T> data) {
        super(errCode, errMsg, data.getContent());
        this.page = new PageBean<>(data);
        this.count = (int) data.getTotalElements();
    }

    public PageResult(String errCode, String errMsg) {
        super(errCode, errMsg);
    }

    public PageBean getPage() {
        return page;
    }

    public void setPage(PageBean page) {
        this.page = page;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }
}
