package dev.flyfish.framework.auditor;

import dev.flyfish.framework.domain.base.Domain;
import reactor.core.publisher.Mono;

/**
 * 异步的对bean进行审查
 *
 * @param <T> 泛型
 */
public interface ReactiveBeanAuditor<T extends Domain> {

    /**
     * 对实体进行审查，并补全相关字段
     *
     * @param data 原数据
     * @return 结果
     */
    Mono<T> audit(T data);
}
