package dev.flyfish.framework.generation.code.strategy;

import dev.flyfish.framework.domain.base.Domain;
import dev.flyfish.framework.generation.CodeRuleStrategy;
import dev.flyfish.framework.utils.UUIDUtils;
import org.springframework.stereotype.Component;

/**
 * UUID代码生成
 *
 * @author wangyu
 */
@Component
public class UUIDCodeRuleStrategy implements CodeRuleStrategy {

    /**
     * 生成代码
     *
     * @param domain 实体
     * @return 结果
     */
    @Override
    public String generate(Domain domain) {
        return UUIDUtils.generateShortUuid();
    }
}
