package dev.flyfish.framework.annotations;

import dev.flyfish.framework.annotations.ConditionOn.List;

import java.lang.annotation.*;

import static java.lang.annotation.ElementType.*;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

/**
 * 条件处理
 * 可以通过条件处理，动态的显隐字段
 * 包括表达式校验，支持repeat
 */
@Target({ANNOTATION_TYPE, FIELD, TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Repeatable(List.class)
public @interface ConditionOn {

    /**
     * @return 判定的字段
     */
    String field() default "";

    /**
     * @return 判定的值
     */
    String value() default "";

    /**
     * @return js表达式
     */
    String expression() default "";

    @Target({FIELD, TYPE, ANNOTATION_TYPE})
    @Retention(RUNTIME)
    @Documented
    @interface List {

        ConditionOn[] value() default {};
    }
}
