package dev.flyfish.framework.annotations;

import org.springframework.core.annotation.AliasFor;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.relational.core.mapping.Table;

import java.lang.annotation.*;

/**
 * 实体表示
 * 同时兼容mongo和mysql
 *
 * @author wangyu
 */
@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Document
@Table
public @interface Entity {

    /**
     * 显示名称
     *
     * @return 结果
     */
    @AliasFor("title")
    String value() default "";

    /**
     * 显示名称（别名）
     *
     * @return 结果
     */
    @AliasFor("value")
    String title() default "";

    /**
     * 表名
     *
     * @return 结果
     */
    @AliasFor(annotation = Table.class, attribute = "value")
    String table() default "";

    /**
     * mongodb集合名
     *
     * @return 结果
     */
    @AliasFor(annotation = Document.class, attribute = "value")
    String collection() default "";
}
