package dev.flyfish.framework.mongodb.config.annotations;

import dev.flyfish.framework.mongodb.repository.factory.DefaultRepositoryFactoryBean;
import dev.flyfish.framework.mongodb.repository.impl.DefaultRepositoryImpl;
import org.springframework.core.annotation.AliasFor;
import org.springframework.data.mongodb.repository.config.EnableMongoRepositories;

import java.lang.annotation.*;

@EnableMongoRepositories(
        repositoryFactoryBeanClass = DefaultRepositoryFactoryBean.class,
        repositoryBaseClass = DefaultRepositoryImpl.class
)
@Target({ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Inherited
public @interface EnableMongoRepo {

    /**
     * 扫描的基本路径
     *
     * @return 结果
     */
    @AliasFor(annotation = EnableMongoRepositories.class)
    String[] basePackages() default {};
}
