package dev.flyfish.framework.r2dbc.metadata.reference;

import dev.flyfish.framework.annotations.Property;
import dev.flyfish.framework.r2dbc.metadata.reference.field.FieldAccessor;
import lombok.AllArgsConstructor;
import lombok.Data;
import org.springframework.data.mapping.PersistentEntity;
import org.springframework.data.mapping.PersistentProperty;

@Data
@Property("一对多关联查询")
@AllArgsConstructor
public class R2dbcCollection {

    @Property("关联实体类")
    private PersistentEntity<?, ?> entity;

    @Property("关联字段")
    private PersistentProperty<?> field;

    @Property("目标值访问器")
    private FieldAccessor accessor;

    public static R2dbcCollection of(PersistentEntity<?, ?> entity, PersistentProperty<?> field, FieldAccessor accessor) {
        return new R2dbcCollection(entity, field, accessor);
    }
}
