package dev.flyfish.framework.r2dbc.query;

import dev.flyfish.framework.domain.base.Domain;
import dev.flyfish.framework.query.spi.QueryFactory;
import dev.flyfish.framework.query.spi.adaptor.CriteriaAdaptor;
import dev.flyfish.framework.query.spi.converter.QueryConverter;
import dev.flyfish.framework.r2dbc.query.adaptor.R2dbcCriteriaAdaptor;
import dev.flyfish.framework.r2dbc.query.converter.R2dbcQueryConverter;
import org.springframework.data.relational.core.query.Criteria;
import org.springframework.data.relational.core.query.Query;
import org.springframework.data.relational.repository.query.RelationalEntityInformation;
import org.springframework.data.repository.core.EntityInformation;

/**
 * r2dbc查询工厂
 *
 * @author wangyu
 */
public class R2dbcQueryFactory implements QueryFactory<Criteria, Query> {

    private final CriteriaAdaptor<Criteria> adaptor = new R2dbcCriteriaAdaptor();

    private final QueryConverter<Query> converter = new R2dbcQueryConverter(adaptor);

    @Override
    public boolean supports(EntityInformation<? extends Domain, String> entity) {
        return entity instanceof RelationalEntityInformation;
    }

    @Override
    public QueryConverter<Query> getConverter() {
        return converter;
    }

    @Override
    public CriteriaAdaptor<Criteria> getAdaptor() {
        return adaptor;
    }
}
