CREATE TABLE IF NOT EXISTS `t_online_form`
(
    `id`          VARCHAR(36)  NOT NULL COMMENT '主键',
    `code`        VARCHAR(32)  NOT NULL COMMENT '编码',
    `name`        VARCHAR(100) NOT NULL COMMENT '名称',
    `description` VARCHAR(500) NULL COMMENT '表单描述',
    `form`        JSON         NULL COMMENT '表单配置',
    `groups`      JSON         NULL COMMENT '表单分组',
    `type`        VARCHAR(10)  NOT NULL DEFAULT 'default' COMMENT '表单样式',
    `width`       INT          NOT NULL DEFAULT 1000 COMMENT '表单宽度',
    `layout`      JSON         NULL COMMENT '默认布局',
    `create_time` DATETIME     NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `modify_time` DATETIME     NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
    `creator`     VARCHAR(36)  NULL COMMENT '创建人名称',
    `creator_id`  VARCHAR(36)  NULL COMMENT '创建人id',
    `modifier`    VARCHAR(36)  NULL COMMENT '修改人名称',
    `modifier_id` VARCHAR(36)  NULL COMMENT '修改人id',
    `delete`      BIT(1)       NOT NULL DEFAULT b'0',
    PRIMARY KEY (`id`),
    UNIQUE KEY (`code`)
) COMMENT '表单定义表';
