package dev.flyfish.framework.user.service;

import dev.flyfish.framework.domain.base.IUser;
import org.springframework.security.core.userdetails.UserDetails;
import reactor.core.publisher.Mono;

/**
 * 用户详情转换器
 *
 * @author wangyu
 */
public interface UserDetailsConverter {

    /**
     * 将用户映射为用户详情，查询所有权限code
     *
     * @param user 用户信息
     * @return 结果
     */
    Mono<UserDetails> mapToUserDetails(IUser user);
}
