package dev.flyfish.framework.beans.meta;

import lombok.Data;
import lombok.experimental.Accessors;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 智能验证实体
 * 封装了通用验证框架和前端校验框架的适配，支持严格统一验证
 *
 * @author wangyu
 */
@Data
@Accessors(chain = true)
public class BeanValidation {

    // 是否必需
    private Boolean required;

    // 类型
    private String type;

    // 验证文案
    private String message;

    // 验证正则
    private String pattern;

    // 验证长度
    private Integer len;

    // 验证最小长度
    private Integer min;

    // 验证最大长度
    private Integer max;

    // 内建的验证器
    private String validator;

    // 生效条件集合
    private List<String> conditions;

    // 额外的选项
    private Map<String, Object> properties = new HashMap<>();

    public BeanValidation prop(String key, Object value) {
        properties.put(key, value);
        return this;
    }
}
